=== modified file 'linaro_media_create/__init__.py'
--- linaro_media_create/__init__.py	2011-01-28 19:50:48 +0000
+++ linaro_media_create/__init__.py	2011-02-10 16:58:11 +0000
@@ -78,7 +78,7 @@
               'only-ubiquity option to allow use of live installer on '
               'boards with 256M memory - like beagle.'))
     parser.add_argument(
-        '--console', action='append', dest='consoles',
+        '--console', action='append', dest='consoles', default=[],
         help=('Add a console to kernel boot parameter; this parameter can be '
               'defined multiple times.'))
     parser.add_argument(

=== modified file 'linaro_media_create/boards.py'
--- linaro_media_create/boards.py	2011-02-01 13:16:43 +0000
+++ linaro_media_create/boards.py	2011-02-10 16:58:11 +0000
@@ -74,17 +74,9 @@
         boot_args_options = 'rootwait ro'
         if cls.extra_boot_args_options is not None:
             boot_args_options += ' %s' % cls.extra_boot_args_options
-        serial_opts = ''
-        if consoles is not None:
-            for console in consoles:
-                serial_opts += ' console=%s' % console
-
-            # XXX: I think this is not needed as we have board-specific
-            # serial options for when is_live is true.
-            if is_live:
-                serial_opts += ' serialtty=%s' % cls.serial_tty
-
-        serial_opts += ' %s' % cls.extra_serial_opts
+        serial_opts = cls.extra_serial_opts
+        for console in consoles:
+            serial_opts += ' console=%s' % console
 
         lowmem_opt = ''
         boot_snippet = 'root=UUID=%s' % rootfs_uuid

=== modified file 'linaro_media_create/tests/test_media_create.py'
--- linaro_media_create/tests/test_media_create.py	2011-02-02 17:38:16 +0000
+++ linaro_media_create/tests/test_media_create.py	2011-02-10 16:58:11 +0000
@@ -344,34 +344,34 @@
 
     def test_vexpress(self):
         boot_cmd = board_configs['vexpress']._get_boot_cmd(
-            is_live=False, is_lowmem=False, consoles=None,
+            is_live=False, is_lowmem=False, consoles=['ttyXXX'],
             rootfs_uuid="deadbeef")
         expected = (
             "setenv bootcmd 'fatload mmc 0:1 0x60008000 uImage; fatload mmc "
             "0:1 0x81000000 uInitrd; bootm 0x60008000 0x81000000'\nsetenv "
-            "bootargs ' console=tty0 console=ttyAMA0,38400n8  "
+            "bootargs 'console=tty0 console=ttyAMA0,38400n8 console=ttyXXX  "
             "root=UUID=deadbeef rootwait ro'\nboot")
         self.assertEqual(expected, boot_cmd)
 
     def test_mx51evk(self):
         boot_cmd = board_configs['mx51evk']._get_boot_cmd(
-            is_live=False, is_lowmem=False, consoles=None,
+            is_live=False, is_lowmem=False, consoles=[],
             rootfs_uuid="deadbeef")
         expected = (
             "setenv bootcmd 'fatload mmc 0:2 0x90000000 uImage; fatload mmc "
             "0:2 0x90800000 uInitrd; bootm 0x90000000 0x90800000'\nsetenv "
-            "bootargs ' console=tty0 console=ttymxc0,115200n8  "
+            "bootargs 'console=tty0 console=ttymxc0,115200n8  "
             "root=UUID=deadbeef rootwait ro'\nboot")
         self.assertEqual(expected, boot_cmd)
 
     def test_ux500(self):
         boot_cmd = board_configs['ux500']._get_boot_cmd(
-            is_live=False, is_lowmem=False, consoles=None,
+            is_live=False, is_lowmem=False, consoles=[],
             rootfs_uuid="deadbeef")
         expected = (
             "setenv bootcmd 'fatload mmc 1:1 0x00100000 uImage; fatload mmc "
             "1:1 0x08000000 uInitrd; bootm 0x00100000 0x08000000'\nsetenv "
-            "bootargs ' console=tty0 console=ttyAMA2,115200n8  "
+            "bootargs 'console=tty0 console=ttyAMA2,115200n8  "
             "root=UUID=deadbeef rootwait ro earlyprintk rootdelay=1 fixrtc "
             "nocompcache mem=96M@0 mem_modem=32M@96M mem=44M@128M "
             "pmem=22M@172M mem=30M@194M mem_mali=32M@224M "
@@ -385,12 +385,12 @@
         config = board_configs['panda']
         config.serial_tty = config._serial_tty
         boot_cmd = config._get_boot_cmd(
-            is_live=False, is_lowmem=False, consoles=None,
+            is_live=False, is_lowmem=False, consoles=[],
             rootfs_uuid="deadbeef")
         expected = (
             "setenv bootcmd 'fatload mmc 0:1 0x80200000 uImage; fatload mmc "
             "0:1 0x81600000 uInitrd; bootm 0x80200000 0x81600000'\nsetenv "
-            "bootargs ' console=tty0 console=ttyO2,115200n8  "
+            "bootargs 'console=tty0 console=ttyO2,115200n8  "
             "root=UUID=deadbeef rootwait ro earlyprintk fixrtc nocompcache "
             "vram=32M omapfb.vram=0:8M mem=463M "
             "ip=none'\nboot")
@@ -403,12 +403,12 @@
         config = board_configs['beagle']
         config.serial_tty = config._serial_tty
         boot_cmd = config._get_boot_cmd(
-            is_live=False, is_lowmem=False, consoles=None,
+            is_live=False, is_lowmem=False, consoles=[],
             rootfs_uuid="deadbeef")
         expected = (
             "setenv bootcmd 'fatload mmc 0:1 0x80000000 uImage; "
             "fatload mmc 0:1 0x81600000 uInitrd; bootm 0x80000000 "
-            "0x81600000'\nsetenv bootargs ' console=tty0 "
+            "0x81600000'\nsetenv bootargs 'console=tty0 "
             "console=ttyO2,115200n8  root=UUID=deadbeef rootwait ro "
             "earlyprintk fixrtc nocompcache vram=12M "
             "omapfb.mode=dvi:1280x720MR-16@60'\nboot")
@@ -421,16 +421,17 @@
         config = board_configs['overo']
         config.serial_tty = config._serial_tty
         boot_cmd = config._get_boot_cmd(
-            is_live=False, is_lowmem=False, consoles=None,
+            is_live=False, is_lowmem=False, consoles=[],
             rootfs_uuid="deadbeef")
         expected = (
             "setenv bootcmd 'fatload mmc 0:1 0x80000000 uImage; "
             "fatload mmc 0:1 0x81600000 uInitrd; bootm 0x80000000 "
-            "0x81600000'\nsetenv bootargs ' console=tty0 "
+            "0x81600000'\nsetenv bootargs 'console=tty0 "
             "console=ttyO2,115200n8  root=UUID=deadbeef rootwait ro "
             "earlyprintk'\nboot")
         self.assertEqual(expected, boot_cmd)
 
+
 class TestUnpackBinaryTarball(TestCaseWithFixtures):
 
     def setUp(self):